local LimitedStockBuyer = select(2,...)
local Util = LimitedStockBuyer
local GUI = LimitedStockBuyer

function Util:CheckForLimitedSupply() --- Checks if the vendor has limited supply items.
	local numMerchantItems = GetMerchantNumItems() 
	local MerchCurrentCheck = 1
	
	while MerchCurrentCheck <= numMerchantItems do
		local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(MerchCurrentCheck)
		if numAvailable ~= -1 then
			return true -- if limited supply available
		end
		MerchCurrentCheck = MerchCurrentCheck+1
	end
	return false --- if not limited supply available
end

function Util:ConvertItemPrice(price)
	--- Need to make neater because this is dog shite
	
	local price = price;
	local gold, copper, silver;
	local PriceString;
	
	--- complex shizz ---
	copper = price % 100
	price = (price - copper ) / 100
	silver = price % 100
	gold = (price - silver) / 100
	
	if gold >= 1 then
		PriceString = gold.."g"..silver.."s"..copper.."c";
	elseif silver >= 1 then
		PriceString = silver.."s"..copper.."c";
	elseif copper >= 1 then
		PriceString = copper.."c";
	else
	 -- Do nothing
	end
	
	return PriceString
end

function Util:BuyAllItems()
	if Util:CheckForLimitedSupply() then
		LimitedStockBuyer:Print("Buying all items")
		
		local numMerchantItems = GetMerchantNumItems() 
		local MerchCurrentCheck = 1
		
		while MerchCurrentCheck <= numMerchantItems do
			local name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(MerchCurrentCheck)
			if numAvailable ~= -1 then
				LimitedStockBuyer:Print("Buying "..name.." x"..numAvailable)
				BuyMerchantItem(MerchCurrentCheck, numAvailable) -- Buys the item.
			end
			MerchCurrentCheck = MerchCurrentCheck+1
		end
		C_Timer.After(0.5,GUI.ReBuild)-- rebuilds gui when finished
	end
	
end